;******************************************************************************
;(C) Copyright 2021 SuperDARN Canada, University of Saskatchewan
;
; Author: Pasha Ponomarenko (University of Saskatchewan)
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; For the GNU General Public License
; see <http://www.gnu.org/licenses/>.
;
; Modifications:
;
;******************************************************************************



;This is a supplementary code for fitacf2_3_comparison_2d.
;Please read instructions therein.
;
pro general_statistics2d, prm2=prm2,prm3=prm3, fit2=fit2,fit3=fit3, grnd=grnd,$
  v_min=v_min, $
  v_max=v_max, $
  dv=dv, $
  w_min=w_min, $
  w_max=w_max, $
  dw=dw, $
  p_min=p_min, $
  p_max=p_max, $
  dp=dp, $
  e_min=e_min, $
  e_max=e_max, $
  de=de, $
  out_stat=out_stat
n_v=round(v_max-v_min)/dv
n_w=round(w_max-w_min)/dw
n_p=round(p_max-p_min)/dp
n_e=round(e_max-e_min)/de

stat_arr_generate2d,$
  v_min=v_min, $
  v_max=v_max, $
  dv=dv, $
  w_min=w_min, $
  w_max=w_max, $
  dw=dw, $
  p_min=p_min, $
  p_max=p_max, $
  dp=dp, $
  e_min=e_min, $
  e_max=e_max, $
  de=de, $
  out_stat=out_stat


qflg2=reform(fit2.qflg)
gflg2=reform(fit2.gflg)
qflg3=reform(fit3.qflg)
gflg3=reform(fit3.gflg)


v2=reform(fit2.v)
p_l2=reform(fit2.p_l)
pwr02=reform(fit2.pwr0)
w_l2=reform(fit2.w_l)
e2=reform(fit2.elv)

v3=reform(fit3.v)
p_l3=reform(fit3.p_l)
pwr03=reform(fit3.pwr0)
w_l3=reform(fit3.w_l)
e3=reform(fit3.elv)

inx_good=where((qflg2 eq 1 and gflg2 eq grnd) and (qflg3 eq 1 and gflg3 eq grnd))
inx_good_elv=where((qflg2 eq 1 and gflg2 eq grnd) and (qflg3 eq 1 and gflg3 eq grnd) and (e2*e3 ne 0));The last term is added here in order
                                                                                                      ;to remove additional "bad" elevation data
                                                                                                      ;identified through XCF power fitting in FITACF2.5
                                                                                                      ;(xqflg = 0)

if grnd eq 0 then begin
	gr2=1-gflg2
	gr3=1-gflg3
endif else begin
	gr2=gflg2
	gr3=gflg3
endelse


if inx_good[0] gt -1 then begin

  histo_2d,v2[inx_good],v3[inx_good], v_min,v_min,dv, dv, n_v,n_v, x_v,x_v, h_vv
  out_stat.h_vv=long(h_vv)

  histo_2d,w_l2[inx_good],w_l3[inx_good], w_min,w_min,dw, dw, n_w,n_w, x_w,x_w, h_ww
  out_stat.h_ww=long(h_ww)

  histo_2d,p_l2[inx_good],p_l3[inx_good], p_min,p_min,dp, dp, n_p,n_p, x_p,x_p, h_pp
  out_stat.h_pp=long(h_pp)

  histo_2d,pwr02[inx_good],pwr03[inx_good], p_min, p_min, dp, dp, n_p, n_p, x_p, x_p, h_p0p0
  out_stat.h_p0p0=long(h_p0p0)

  histo_2d,e2[inx_good_elv],e3[inx_good_elv], e_min, e_min, de, de, n_e, n_e, x_e, x_e, h_ee
  out_stat.h_ee=long(h_ee)



  out_stat.n_tot=long(n_elements(inx_good))

endif


end
